; Program to send DiSEqC commands to SUP-2400
; need to send E2 03 00 to switch up converter on
; and E2 02 00 to switch off
; Send MSB first, odd parity bit last

; This was coded using subroutines however the time taken to call and return
; caused too much delay. Instead it has been coded (crudely) using macros
; which, although ugly, works well considering this is running on a BASIC
; interpreter.
; A pushbutton and LED have been added. On power-up the On command is sent
; and the LED lights. Pressing the button then cycles between On and Off
; commands with the LED lighting or extinguishing appropriately
; No crystal is used - the SUP2400 I use works fine with the low
; tolerance built-in oscillator

; Pin connections:
; C.0 LED
; C.1
; C.2
; C.2 22kHz tone out
; C.3 Pushbutton switch active high
; C.4 sync pulse out for testing


setfreq m32 ; Max speed for best accuracy

#macro send1
	pwmout pwmdiv4, C.2, 90, 181 ; 22000Hz at 50% @ 32MHz
	pauseus 400  ; 0.5ms
	pwmout C.2, off
	pauseus 800 ; 1.0ms
#endmacro

#macro send0
	pwmout pwmdiv4, C.2, 90, 181 ; 22000Hz at 50% @ 32MHz
	pauseus 800  ; 0.5ms
	pwmout C.2, off
	pauseus 400 ; 1.0ms
#endmacro

input C.3

pause 800 ; Startup delay 100ms (32MHz clock) to allow the SUP-2400 time to wake up

switch_on:

	pulsout C.4, 20
	high C.0

	rem E2
	send1
	send1
	send1
	send0
	send0
	send0
	send1
	send0
	send1 ; parity

	rem 03 (On command)
	send0
	send0
	send0
	send0
	send0
	send0
	send1
	send1
	send1 ; parity

	Rem 00
	send0
	send0
	send0
	send0
	send0
	send0
	send0
	send0
	send1 ; parity

loopw1: button C.3, 1, 255, 0, b0, 1, switch_off
	pause 80
	goto loopw1

switch_off:

	pulsout C.4, 20
	low C.0

	rem E2
	send1
	send1
	send1
	send0
	send0
	send0
	send1
	send0
	send1 ; parity

	rem 02 (Off command)
	send0
	send0
	send0
	send0
	send0
	send0
	send1
	send0
	send0 ; parity

	Rem 00
	send0
	send0
	send0
	send0
	send0
	send0
	send0
	send0
	send1 ; parity

loopw2: button C.3, 1, 255, 0, b0, 1, switch_on
	pause 80
	goto loopw2
